using System.Collections.Generic;
using System.Linq;

namespace LinqExamples.Extensions
{
  public static class LinqExtensions
  {
    public static IEnumerable<int> OddNumbers(this IEnumerable<int> numbers)
    {
      return numbers.Where(OddNumberPredicate);
    }

    public static IEnumerable<int> EvenNumbers(this IEnumerable<int> numbers)
    {
      return numbers.Where(EvenNumberPredicate);
    }

    private static bool EvenNumberPredicate(int c)
    {
      return c % 2 == 0;
    }

    private static bool OddNumberPredicate(int c)
    {
      return !EvenNumberPredicate(c);
    }
  }
}