﻿using System;
using System.Collections.Generic;

namespace LinqExamples.Extensions.MyLINQ
{
  public static class HowCanBeLinqImplemented
  {
    public static IEnumerable<TSource> MyWhere<TSource>(this IEnumerable<TSource> source, Func<TSource, bool> predicate)
    {
      if (source == null)
      {
        throw new ArgumentNullException("source");
      }

      if (predicate == null)
      {
        throw new ArgumentNullException("predicate");
      }

      return WhereImpl(source, predicate);
    }

    private static IEnumerable<TSource> WhereImpl<TSource>(this IEnumerable<TSource> source, Func<TSource, bool> predicate)
    {
      foreach (TSource item in source)
      {
        if (predicate(item))
        {
          yield return item;
        }
      }
    }

    // TODO Select implementation

    // TODO Count implementation

    // TODO ALL implementation

    // TODO Any implementation
  }
}
