using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using LinqExamples.Data;
using LinqExamples.Extensions;

namespace LinqExamples
{
  internal partial class LinqOperatorExamples
  {
    private void ConversionExamples()
    {
      var animals = new IAnimal[] { new Dog("Alk"), new Cat("Micka"), new Dog("Rek"), new Dog("Fk"), new Cat("Mike"), };
      animals.OfType<Dog>().WriteLineAll("OfType - dog");
      animals.OfType<Cat>().WriteLineAll("OfType - cat");

      var cats = animals.Cast<Cat>();
      cats.WriteLineAll("Throw exception");

      // ToArray
      // ToList
      // ToDictionary
      // ToLookup
      // AsEnumerable
      // AsQueryable
    }

    private interface IAnimal
    {
      string Name { get; set; }
    }

    private class Dog : IAnimal
    {
      public string Name { get; set; }

      public Dog(string name)
      {
        Name = name;
      }
    }

    private class Cat : IAnimal
    {
      public string Name { get; set; }

      public Cat(string name)
      {
        Name = name;
      }

    }

  }
}