using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using LinqExamples.Data;
using LinqExamples.Extensions;

namespace LinqExamples
{
  internal partial class LinqOperatorExamples
  {
     private void FilteringExamles()
    {
      Where();

      int[] numbers = { 5, 4, 5, 1, 3, 9, 8, 6, 6, 5, 7 };
      numbers.WriteAll("Numbers");

      numbers.Take(3).WriteAll("Take 3");
      numbers.Skip(6).WriteAll("Skip 6");      
      numbers.TakeWhile(n => n > 3).WriteAll("Take while n > 3");
      numbers.SkipWhile(n => n < 6).WriteAll("Skip while n < 6");
      numbers.Distinct().WriteAll("Distinct");

      //PagingExample();
    }

    private void Where()
    {
      var products = _dataContext.GetProducts();
      var notInStock = products.Where(c => c.UnitsInStock == 0);
      notInStock.Select(p => p.ProductName).WriteLineAll("Products which is not in stock:");

      var inStock = from p in products
        where p.UnitsInStock > 100
        select p;
      inStock.Select(p => p.ProductName).WriteLineAll("Products which is not in stock:");
    }

    private void PagingExample()
    {
      Console.Clear();
      int pageSize = 10;
      int pageIndex = 0;
      var products = _dataContext.GetProducts();
      var productsOnPage = products.Skip(pageIndex*pageSize).Take(pageSize);
      productsOnPage.OrderBy(c=>c.ProductName).Select(c => c.ProductName).WriteLineAll(string.Format("Page index = {0}", pageIndex));
    }
  }
}