using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using LinqExamples.Data;
using LinqExamples.Extensions;

namespace LinqExamples
{
  internal partial class LinqOperatorExamples
  {
    private void SetOperatorsExamples()
    {
      int[] numbersA = { 0, 2, 4, 5, 6, 8, 9 };
      int[] numbersB = { 1, 3, 5, 7, 8 };
      numbersA.WriteAll("NumbersA");
      numbersB.WriteAll("NumbersB");
      Console.WriteLine();

      numbersA.Concat(numbersB).WriteAll("NumbersA Concat NumbersB");
      //numbersA.Union(numbersB).WriteAll("NumbersA Union NumbersB");
      //numbersA.Intersect(numbersB).WriteAll("NumbersA Intersect NumbersB");
      //numbersA.Except(numbersB).WriteAll("NumbersA Except NumbersB");
      //numbersB.Except(numbersA).WriteAll("NumbersB Except NumbersA");

      //UnionOnReferenceDataTypes();
    }

    private static void UnionOnReferenceDataTypes()
    {
      var unionExampleClass = new UnionExampleClass("A");
      var setA = new[] { unionExampleClass, new UnionExampleClass("B") };
      var setB = new[] { unionExampleClass, new UnionExampleClass("B") };
      setA.Union(setB).Select(c => c.Name).WriteAll("setA union setB - reference types");
    }

    private class UnionExampleClass
    {
      public UnionExampleClass(string name)
      {
        Name = name;
      }

      public string Name { get; set; }
    }

  }
}