﻿using System;
using System.Linq;
using LinqExamples.Extensions;

namespace LinqExamples
{
  public class QueryExecutionExamples
  {
    public void Show()
    {
      QueryEvaluation();
      ReuseQuery();
    }

    private static void QueryEvaluation()
    {
      int[] numbers = { 5, 4, 1, 3, 9, 8, 6, 7, 2, 0 };

      QueryEvaluation01(numbers);
      QueryEvaluation02(numbers);
    }

    private static void QueryEvaluation01(int[] numbers)
    {
      int i = 0;
      var simpleQuery = from num in numbers
        select ++i;
      // numbers.Select(num => ++i)

      Console.WriteLine("i = {0}", i);

      foreach (var item in simpleQuery)
      {
        Console.WriteLine("v = {0}, i = {1}", item, i);
      }
    }

    private static void QueryEvaluation02(int[] numbers)
    {
      int i = 10;
      var simpleQuery = from num in numbers
                        select num * i;
      // numbers.Select(num => num * i)


      i = 20;

      simpleQuery.WriteLineAll("num * i");
    }

    private static void ReuseQuery()
    {
      int[] numbers = {5, 4, 1, 3, 9, 8, 6, 7, 2, 0};
      var query = numbers.Where(n => n <= 3);
      
      query.WriteLineAll("n <= 3:");
      
      var oddNumbers = query.Where(n => n % 2 == 0);
      
      oddNumbers.WriteLineAll("n <= 3 && n % 2 == 0:");

      for (int i = 0; i < numbers.Length; i++)
      {
        numbers[i] = -numbers[i];
      }
      
      // numbers = numbers.Select(n => -n).ToArray();

      query.WriteLineAll("n <= 3:");
      oddNumbers.WriteLineAll("n <= 3 && n%2 == 0:");

    }
  }
}
