﻿using System.Linq;
using LinqExamples.Extensions;

namespace LinqExamples
{
  internal partial class SimpleLinqExample
  {    
    private void Order()
    {
      var oddNumbers = _numbers.OrderBy(c => c);
      oddNumbers.WriteLineAll("Ordered numbers:");
    }

    private void Distinct()
    {
      var oddNumbers = _numbers.Distinct();

      oddNumbers.WriteLineAll("Distinct numbers:");
    }

    private void CombiningOperators()
    {
      _numbers
        .Where(n => n % 2 == 1)
        .OrderBy(c => c)
        .Distinct()
        .WriteLineAll("Distinct ordered odd numbers");
    }
  }
}